package client;

import service.*;
import xmltypes.*;

import java.io.*;

import org.cybergarage.upnp.*;
import org.cybergarage.upnp.device.*;
import org.cybergarage.upnp.control.*;
import org.cybergarage.http.*;
import org.cybergarage.upnp.ssdp.*;
import org.cybergarage.upnp.event.*;

public class ValidityListener implements EventListener, NotifyListener 
{
    private ControlPoint ctrlPoint = new ControlPoint();
    
    private StateVariable timeVar;
    private Device lastDeviceSeen;

    public static void main(String[] args) {
	ValidityListener client = new ValidityListener();
	
	Object keepAlive = new Object();
	synchronized(keepAlive) {
	    try {
		// Wait for a "notify" from another thread
		// that will never be sent.
		// So we stay alive for ever
		keepAlive.wait();
	    } catch(java.lang.InterruptedException e) {
		// do nothing
	    }
	}
    }

    public ValidityListener()
    {

	ctrlPoint.addNotifyListener(this);
	ctrlPoint.addEventListener(this);
	ctrlPoint.start();
    }

    ////////////////////////////////////////////////
    // HttpRequestListner
    ////////////////////////////////////////////////

    /*
    public void httpRequestRecieved(HTTPRequest httpReq)
    {
	System.out.println("HTTP request: " + httpReq);
	
	String uri = httpReq.getURI();
	if (uri.startsWith(PRESENTATION_URI) == false) {
	    super.httpRequestRecieved(httpReq);
	    return;
	}
    }
    */

    public void eventNotifyReceived(String uuid, long seq, 
				    String varName, String value) {
	System.out.println("Name: \"" +  varName + "\"");
	System.out.println("Value: \"" +  value + "\"");
    }


    public void deviceNotifyReceived(SSDPPacket ssdpPacket) { 

	// System.out.println("New SSDPPacket, all " + ssdpPacket);
	/* There doesn;t seem to be a simple way of getting the new
	 * device from the packet, even though CyberLink creates a
	 * new device from it - and adds it to a list. Looks like we
	 * have to get the whole list and search through it for the
	 * device created by this packet :-(
	 */
	DeviceList devList = ctrlPoint.getDeviceList();
	Device dev = null;
	System.out.println("Devices: " + devList.size());
	for (int n = 0; n < devList.size(); n++) {
	    if (devList.getDevice(n).getSSDPPacket() == ssdpPacket) {
		System.out.println("Found the new device matching SSDP packet");
		dev = devList.getDevice(n);
		break;
	    }
	}
	if (dev == null) {
	    // couldn't find it? That shouldn't happen...
	    return;
	}

	if (dev.getDeviceType().equals("urn:schemas-upnp-org:device:clock:1")) {
	    ServiceList services = dev.getServiceList();
	    for (int m = 0; m < services.size(); m++) {
		Service svc = services.getService(m);
		if (svc.getServiceType().equals("urn:schemas-upnp-org:service:timer:1")) {
		    System.out.println("Subscribing to timer events");
		    ctrlPoint.subscribe(svc);
		}
	    }
	}
    } 

    private ServiceList getTimerServices() {
	ServiceList timerServices = new ServiceList();

	DeviceList devList = ctrlPoint.getDeviceList();
	System.out.println("Devices: " + devList.size());
	for (int n = 0; n < devList.size(); n++) {
	    Device dev = devList.getDevice(n);
	    System.out.println("  type " +  dev.getDeviceType());
	    if (dev.getDeviceType().equals("urn:schemas-upnp-org:device:clock:1")) {
		ServiceList services = dev.getServiceList();
		for (int m = 0; m < services.size(); m++) {
		    Service svc = services.getService(m);
		    if (svc.getServiceType().equals("urn:schemas-upnp-org:service:timer:1")) {
			timerServices.add(svc);
		    }
		}
	    }
	}
	return timerServices;
    }
}

